function [RGB,sift,locations]=compute_features_cc(opts,im,ii)
% computes the RGB, and SIFT features together with the locations

[yy,xx]=ndgrid(32:16:(size(im,1)-32),32:16:(size(im,2)-21));
locations=[xx(:) yy(:) zeros(size(xx(:),1),1)];

%[locations, sift] = compute_sift_grid(im,8,2,4);        % SIFT computation based on DORKO implementation (used in ICCV and TIP publication)

% The SIFT computation is based on the SIFT implementation which can be downloaded from:
% http://www.vlfeat.org/~vedaldi/code/sift.html
im2               = imsmooth(sum(im,3),4) ;
im2=im2./max(im2(:));

sift              = siftdescriptor(im2,locations',4);
sift=sift';
locations=locations(:,1:2);

RGB               = compute_RGB(im,locations,8);        % compute RGB features on same locations

% remove features which are within the MASK             
loc_mask = (locations(:,1)<opts.mask(ii,1) | locations(:,1)>opts.mask(ii,3)) | ( locations(:,2)<opts.mask(ii,2) | locations(:,2)>opts.mask(ii,4));

RGB=RGB(loc_mask,:);
sift=sift(loc_mask,:);
locations=locations(loc_mask,:);
