
all_C=[];
all_S=[];

%% compute vocabularies 
for ii=1:opts.nImg
    if(trainset(ii))  % for all images in trainset of this split
        fprintf(1,'Split %d : Processing image number %d\n',split_counter,ii);
        im=read_im_NTSC_SHI(opts,ii);
        % learn vocabularies after randomly applying one of the cc-methods
        methodC=ceil(rand(1)*num_ll);  
        [yy,xx]=ndgrid(1:size(im,1),1:size(im,2));                    
        mask_square = 1- (xx<opts.mask(ii,1) | xx>opts.mask(ii,3) | yy<opts.mask(ii,2) | yy>opts.mask(ii,4) );          
        if(methodC>1)       % apply cc method
            [white_R ,white_G ,white_B,im2] = general_cc(im,NN(methodC),PP(methodC),SS(methodC),mask_square);
        else                % no cc
            im2=im;
        end
        [RGB,sift]=compute_features_cc(opts,im2,ii);  
        selection=randperm(size(RGB,1));                        % only part of features is used to construct vocabularies
        all_C=[all_C;RGB(selection(1:num_samples),:)];
        all_S=[all_S;sift(selection(1:num_samples),:)];     
    end
end
[IDX,vocC]=kmeans(all_C,NC,'EmptyAction','singleton');
[IDX,vocS]=kmeans(all_S,NS,'EmptyAction','singleton');

save(sprintf('%s/vocRGB_%d.mat',opts.datapath,split_counter),'vocC');
save(sprintf('%s/vocSIFT_%d.mat',opts.datapath,split_counter),'vocS');

%% compute the images represented in the visual_vocabularies for the images under white_illuminant. This is used to learn the semantic topics.
for ii=1:opts.nImg
    if(trainset(ii)) 
        fprintf(1,'Split %d : Processing image number %d\n',split_counter,ii);

        im=read_im_NTSC_SHI(opts,ii);
        im2=change_illuminant(im,opts.illuminants(ii,1),opts.illuminants(ii,2),opts.illuminants(ii,3),1,0);        % convert illuminant to white lighting

        [RGB,sift,locations]=compute_features_cc(opts,im2,ii);
        listS{ii}=features2voc(sift,vocS);
        listC{ii}=features2voc(RGB,vocC);

        listP{ii}=ceil(locations(:,2)/size(im,1)*Npos)+floor(locations(:,1)/size(im,2)*Npos)*Npos;
        listL{ii}=locations;                                                                
    end    
end

save(sprintf('%s/listS_%d.mat',opts.datapath,split_counter),'listS')
save(sprintf('%s/listC_%d.mat',opts.datapath,split_counter),'listC')
save(sprintf('%s/listP_%d.mat',opts.datapath,split_counter),'listP')
save(sprintf('%s/listL_%d.mat',opts.datapath,split_counter),'listL')
